## discount 2.2.3b8

=== msvc/Makefile ===
# NMAKE Makefile to build Discount with Visual C++
<<<<<<< HEAD:msvc/Makefile
CFLAGS	=	/nologo /MP /MD /EHa /Zi \
=======
CFLAGS	=	/nologo /MP /MDd /EHa /Zi \
>>>>>>> gethopt-uber-alles:msvc/Makefile
			/D_CRT_SECURE_NO_DEPRECATE /D_CRT_NONSTDC_NO_DEPRECATE /D_SCL_SECURE_NO_WARNINGS \
			/I.
LIBOBJ	=	mkdio.obj markdown.obj dumptree.obj generate.obj \
			resource.obj docheader.obj version.obj toc.obj css.obj \
			xml.obj Csio.obj xmlpage.obj basename.obj emmatch.obj \
			github_flavoured.obj setup.obj tags.obj html5.obj flags.obj
MKDLIB	= libmarkdown.lib
PGMS=markdown
SAMPLE_PGMS=mkd2html makepage
# modules that markdown, makepage, mkd2html, &tc use
COMMON=pgm_options.obj gethopt.obj

# Assumes VERSION is a single-line file
VERSION = \
	!INCLUDE <VERSION>

default:	all

all:	$(MKDLIB) $(PGMS) $(SAMPLE_PGMS) 

$(MKDLIB):	$(LIBOBJ)
	if exist $(MKDLIB) del $(MKDLIB)
	lib /out:$(MKDLIB) $(LIBOBJ)

config.h: msvc/config.h.vc
	copy /Y msvc\config.h.vc config.h

version.c: version.c.in
	powershell.exe -Command "(gc version.c.in) -replace '@TABSTOP@', 'TABSTOP' | Out-File version.c"

version.obj: version.c VERSION config.h
	$(CC) $(CFLAGS) -DBRANCH="" -DVERSION=\"$(VERSION)\" /c version.c

mkdio.h: mkdio.h.in
	powershell.exe -Command "(gc mkdio.h.in) -replace '@DWORD@', 'unsigned long' | Out-File mkdio.h"

mkdio.obj: mkdio.h

tags.obj: tags.c cstring.h tags.h blocktags

pgm_options.obj: pgm_options.c mkdio.h config.h
	$(CC) $(CFLAGS) /c pgm_options.c

mktags: mktags.obj
	$(CC) $(CFLAGS) mktags.obj

blocktags: mktags
	.\mktags.exe > blocktags

mkd2html:  mkd2html.obj $(MKDLIB) mkdio.h gethopt.h gethopt.obj
	$(CC) $(CFLAGS) $(LFLAGS) mkd2html.obj gethopt.obj $(MKDLIB)

markdown: main.obj $(COMMON) $(MKDLIB)
	$(CC) $(CFLAGS) $(LFLAGS) /Femarkdown main.obj $(COMMON) $(MKDLIB)

makepage:  makepage.c $(COMMON) $(MKDLIB) mkdio.h
	$(CC) $(CFLAGS) $(LFLAGS) makepage.c $(COMMON) $(MKDLIB)

clean:
	-del config.h blocktags mkdio.h version.c
	-del *.obj *.lib
	-del *.pdb *.exp
	-del *.ilk *.exe

## discount 2.1.0

=== debian/changelog ===
discount (2.1.0-1) unstable; urgency=low

  * New upstream release 
  * Update debian/changelog:
    - Trim leading './' from files path
    - Add file pgm_options.c to copyright

 -- Alessandro Ghedini <al3xbio@gmail.com>  Wed, 13 Jul 2011 20:54:07 +0200

discount (2.0.9-1) unstable; urgency=low

  * New upstream release
  * Drop fix-spelling-error patch (merged upstream)
  * Bump Standards-Version to 3.9.2 (no changes needed)

 -- Alessandro Ghedini <al3xbio@gmail.com>  Wed, 04 May 2011 19:19:50 +0200

discount (2.0.8-1) unstable; urgency=low

  * New upstream release 
  * Drop fix-manpages-errors patch (merged upstream)
  * Update symbols file for libmarkdown2
  * Add fix-spelling-error patch
  * Enable all stable optional features

 -- Alessandro Ghedini <al3xbio@gmail.com>  Thu, 17 Mar 2011 14:59:57 +0100

discount (2.0.6-1) unstable; urgency=low

  * New upstream release
  * Update symbols file for libmarkdown2

 -- Alessandro Ghedini <al3xbio@gmail.com>  Sat, 19 Feb 2011 18:40:54 +0100

discount (2.0.4-1) unstable; urgency=low

  * Initial release (Closes: #608709)

 -- Alessandro Ghedini <al3xbio@gmail.com>  Fri, 14 Jan 2011 17:21:25 +0100

=== debian/control ===
Source: discount
Section: text
Priority: optional
Maintainer: Alessandro Ghedini <al3xbio@gmail.com>
Build-Depends: debhelper (>= 7.0.50~)
Standards-Version: 3.9.2
Homepage: http://www.pell.portland.or.us/~orc/Code/discount/
Vcs-Git: git://git.debian.org/collab-maint/discount.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/discount.git;a=summary

Package: discount
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libmarkdown2 (= ${binary:Version})
Conflicts: markdown, libtext-markdown-perl
Description: Implementation of Markdown markup language in C
 Discount is an implementation of John Gruber's Markdown markup
 language. It implements all of the language described in the Markdown
 syntax document and passes the Markdown 1.0 test suite.
 .
 This package provides the discount excutables.

Package: libmarkdown2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Implementation of Markdown markup language in C (library)
 Discount is an implementation of John Gruber's Markdown markup
 language. It implements all of the language described in the Markdown
 syntax document and passes the Markdown 1.0 test suite.
 .
 This package provides the libmarkdown generated from discount.

Package: libmarkdown2-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libmarkdown2 (= ${binary:Version})
Description: Implementation of Markdown markup language in C (development files)
 Discount is an implementation of John Gruber's Markdown markup
 language. It implements all of the language described in the Markdown
 syntax document and passes the Markdown 1.0 test suite.
 .
 This package provides the development file for libmarkdown.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	./configure.sh --shared --enable-all-features

override_dh_auto_install:
	dh_install

=== debian/watch ===
version=3

http://www.pell.portland.or.us/~orc/Code/discount/discount-(.*)\.tar\.bz2

## discount 2.1.1.3

=== debian/changelog ===
discount (2.1.1.3-1) unstable; urgency=low

  * New upstream release
  * Update *.symbols file
  * Add mktags and blocktags to debian/clean
  * Explicitly list manpages to install

 -- Alessandro Ghedini <al3xbio@gmail.com>  Wed, 03 Aug 2011 11:14:34 +0200

## discount 2.1.2

=== debian/changelog ===
discount (2.1.2-2) unstable; urgency=low

  * Install correct header file mkdio.h in -dev package

 -- Alessandro Ghedini <al3xbio@gmail.com>  Fri, 28 Oct 2011 12:40:27 +0200

discount (2.1.2-1) unstable; urgency=low

  * New upstream release
  * Bump debhlper compat level to 8
  * Add librarian.sh to debian/clean
  * Manually enable additional features: id anchor, github tags, fenced code
  * Do not build custom memory allocation functions (for debug only)

 -- Alessandro Ghedini <al3xbio@gmail.com>  Sun, 02 Oct 2011 19:22:10 +0200

## discount 2.1.3

=== debian/changelog ===
discount (2.1.3-3) unstable; urgency=low

  * Install mkdio.h in a Multi-Arch path (Closes: #676240)

 -- Alessandro Ghedini <ghedo@debian.org>  Tue, 05 Jun 2012 19:30:28 +0200

discount (2.1.3-2) unstable; urgency=low

  * Update debian/copyright format as in Debian Policy 3.9.3
  * Bump Standards-Version to 3.9.3
  * Bump debhelper compat level to 9
    - Make *.install files executable to generate multi-arch path
  * Honour the CPPFLAGS variable too during build
  * Email change: Alessandro Ghedini -> ghedo@debian.org
  * Add Multi-Arch headers
  * Add libmarkdown2-dbg package
  * Do not use GitHub URL in debian/watch
  * Add 01_honour-build-flags.patch

 -- Alessandro Ghedini <ghedo@debian.org>  Sun, 03 Jun 2012 16:49:41 +0200

discount (2.1.3-1) unstable; urgency=low

  * New upstream release
    - <br> is not a block-level html element (Closes: #656122)
  * Use GitHub URL in debian/watch

 -- Alessandro Ghedini <al3xbio@gmail.com>  Wed, 18 Jan 2012 20:40:30 +0100

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,9 @@
 Source: discount
 Section: text
 Priority: optional
-Maintainer: Alessandro Ghedini <al3xbio@gmail.com>
-Build-Depends: debhelper (>= 7.0.50~)
-Standards-Version: 3.9.2
+Maintainer: Alessandro Ghedini <ghedo@debian.org>
+Build-Depends: debhelper (>= 9)
+Standards-Version: 3.9.3
 Homepage: http://www.pell.portland.or.us/~orc/Code/discount/
 Vcs-Git: git://git.debian.org/collab-maint/discount.git
 Vcs-Browser: http://git.debian.org/?p=collab-maint/discount.git;a=summary
@@ -23,6 +23,8 @@
 Section: libs
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
+Pre-Depends: ${misc:Pre-Depends}
+Multi-Arch: same
 Description: Implementation of Markdown markup language in C (library)
  Discount is an implementation of John Gruber's Markdown markup
  language. It implements all of the language described in the Markdown
@@ -34,9 +36,23 @@
 Section: libdevel
 Architecture: any
 Depends: ${misc:Depends}, libmarkdown2 (= ${binary:Version})
+Multi-Arch: same
 Description: Implementation of Markdown markup language in C (development files)
  Discount is an implementation of John Gruber's Markdown markup
  language. It implements all of the language described in the Markdown
  syntax document and passes the Markdown 1.0 test suite.
  .
  This package provides the development file for libmarkdown.
+
+Package: libmarkdown2-dbg
+Priority: extra
+Section: debug
+Architecture: any
+Depends: ${misc:Depends}, libmarkdown2 (= ${binary:Version})
+Multi-Arch: same
+Description: Implementation of Markdown markup language in C (debug)
+ Discount is an implementation of John Gruber's Markdown markup
+ language. It implements all of the language described in the Markdown
+ syntax document and passes the Markdown 1.0 test suite.
+ .
+ This package provide the debugging symbols for discount.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

%:
	dh $@

CFLAGS += $(dpkg-buildflags --get CPPFLAGS)

override_dh_auto_configure:
	./configure.sh --shared    \
		--with-id-anchor   \
		--with-github-tags \
		--with-fenced-code

override_dh_auto_install:
	dh_install

override_dh_strip:
	dh_strip -plibmarkdown2 --dbg-package=libmarkdown2-dbg
	dh_strip --remaining-packages

## discount 2.1.5a

=== debian/changelog ===
discount (2.1.5a-1) unstable; urgency=low

  * New upstream release
  * Refresh 01_honour-build-flags.patch

 -- Alessandro Ghedini <ghedo@debian.org>  Thu, 09 Aug 2012 16:01:47 +0200

discount (2.1.5-1) unstable; urgency=low

  * New upstream release
  * Refresh 01_honour-build-flags.patch
  * Update symbols file

 -- Alessandro Ghedini <ghedo@debian.org>  Wed, 08 Aug 2012 21:38:30 +0200

## discount 2.1.6

=== debian/changelog ===
discount (2.1.6-2) unstable; urgency=low

  * Enable both Discount and Extra definition lists (Closes: #705732)

 -- Alessandro Ghedini <ghedo@debian.org>  Sun, 28 Apr 2013 22:02:02 +0200

discount (2.1.6-1) unstable; urgency=low

  * New upstream release
  * Bump Standards-Version to 3.9.4 (no changes needed)
  * Minor improvements to the packages' descriptions
  * Change upstream license from BSD 4-clause to BSD 3-clause

 -- Alessandro Ghedini <ghedo@debian.org>  Sun, 17 Mar 2013 16:49:57 +0100

=== debian/control ===
Source: discount
Section: text
Priority: optional
Maintainer: Alessandro Ghedini <ghedo@debian.org>
Build-Depends: debhelper (>= 9)
Standards-Version: 3.9.4
Homepage: http://www.pell.portland.or.us/~orc/Code/discount/
Vcs-Git: git://git.debian.org/collab-maint/discount.git
Vcs-Browser: http://git.debian.org/?p=collab-maint/discount.git;a=summary

Package: discount
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, libmarkdown2 (= ${binary:Version})
Conflicts: markdown, libtext-markdown-perl
Description: implementation of the Markdown markup language in C
 Discount is an implementation of John Gruber's Markdown markup language. It
 implements all of the language described in the Markdown syntax document and
 passes the Markdown 1.0 test suite.
 .
 This package provides the discount excutables.

Package: libmarkdown2
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Multi-Arch: same
Description: implementation of the Markdown markup language in C (library)
 Discount is an implementation of John Gruber's Markdown markup language. It
 implements all of the language described in the Markdown syntax document and
 passes the Markdown 1.0 test suite.
 .
 This package provides the libmarkdown generated from discount.

Package: libmarkdown2-dev
Section: libdevel
Architecture: any
Depends: ${misc:Depends}, libmarkdown2 (= ${binary:Version})
Multi-Arch: same
Description: implementation of the Markdown markup language in C (dev files)
 Discount is an implementation of John Gruber's Markdown markup language. It
 implements all of the language described in the Markdown syntax document and
 passes the Markdown 1.0 test suite.
 .
 This package provides the development file for libmarkdown.

Package: libmarkdown2-dbg
Priority: extra
Section: debug
Architecture: any
Depends: ${misc:Depends}, libmarkdown2 (= ${binary:Version})
Multi-Arch: same
Description: implementation of Markdown markup language in C (debug)
 Discount is an implementation of John Gruber's Markdown markup language. It
 implements all of the language described in the Markdown syntax document and
 passes the Markdown 1.0 test suite.
 .
 This package provide the debugging symbols for discount.

=== debian/watch ===
version=3
http://www.pell.portland.or.us/~orc/Code/discount/discount-(.*)\.tar\.bz2

## discount 2.1.7

=== debian/changelog ===
discount (2.1.7-1) unstable; urgency=low

  * New upstream release
    - Fix non-ASCII text handling inside emphasis (Closes: #722305)
  * Fix license name in d/copyright
  * Fix copyright for toc.c
  * Fix lintian vcs-field-not-canonical
  * Use GitHub URL in watch file for now
  * Refresh patch
  * Fix license text in d/copyright

 -- Alessandro Ghedini <ghedo@debian.org>  Sat, 19 Oct 2013 14:34:54 +0200

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,8 @@
 	./configure.sh --shared    \
 		--with-id-anchor   \
 		--with-github-tags \
-		--with-fenced-code
+		--with-fenced-code \
+		--with-dl=both
 
 override_dh_auto_install:
 	dh_install

## discount 2.1.8

=== debian/changelog ===
discount (2.1.8-2) unstable; urgency=medium

  * Add 02_fix-email-mangling.patch to fix email mangling (Closes: #782315)

 -- Alessandro Ghedini <ghedo@debian.org>  Fri, 10 Apr 2015 14:42:53 +0200

discount (2.1.8-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 3.9.6 (no changes needed)
  * Update upstream author email address
  * Enable deterministic email mangling (Closes: #762622)

 -- Alessandro Ghedini <ghedo@debian.org>  Sat, 31 Jan 2015 21:33:36 +0100

=== debian/control ===
--- 
+++ 
@@ -3,10 +3,10 @@
 Priority: optional
 Maintainer: Alessandro Ghedini <ghedo@debian.org>
 Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.4
+Standards-Version: 3.9.6
+Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/discount.git
+Vcs-Git: git://anonscm.debian.org/collab-maint/discount.git
 Homepage: http://www.pell.portland.or.us/~orc/Code/discount/
-Vcs-Git: git://git.debian.org/collab-maint/discount.git
-Vcs-Browser: http://git.debian.org/?p=collab-maint/discount.git;a=summary
 
 Package: discount
 Architecture: any

=== debian/rules ===
--- 
+++ 
@@ -11,7 +11,8 @@
 		--with-id-anchor   \
 		--with-github-tags \
 		--with-fenced-code \
-		--with-dl=both
+		--with-dl=both     \
+		--debian-glitch
 
 override_dh_auto_install:
 	dh_install

## discount 2.2.2

=== debian/changelog ===
discount (2.2.2-1+deb9u1) stretch-security; urgency=high

  * Non-maintainer upload.
  * Fix CVE-2018-11468, CVE-2018-11503, CVE-2018-11504 and CVE-2018-12495.
    Several heap-based buffer over-reads were found in discount that allowed
    remote attackers to cause a denial-of-service via specially crafted files.

 -- Markus Koschany <apo@debian.org>  Thu, 13 Sep 2018 22:43:24 +0200

discount (2.2.2-1) unstable; urgency=medium

  * New upstream release
  * Refresh patches

 -- Alessandro Ghedini <ghedo@debian.org>  Thu, 19 Jan 2017 22:42:00 +0000

discount (2.2.1-1) unstable; urgency=medium

  * New upstream release
  * Refresh patches

 -- Alessandro Ghedini <ghedo@debian.org>  Sat, 19 Nov 2016 16:29:22 +0000

discount (2.2.0+git20160802-1) unstable; urgency=medium

  * New upstream release
    - Fix FTBFS on architectures where char is unsigned (Closes: #826197)
  * Drop 03_fix-tests.patch (merged upstream)
  * Properly label license texts.
    Thanks to Francesco Poli for the patch (Closes: #826249)
  * Add 03_fix-typo.patch to fix spelling-error-in-manpage
  * Drop 02_fix-makepage-man.patch
    The documentation mismatch was caused by a bug in the code,
    not the manpage (Closes: #813977)

 -- Alessandro Ghedini <ghedo@debian.org>  Tue, 02 Aug 2016 16:55:25 +0100

discount (2.2.0-1) unstable; urgency=medium

  * New upstream release
  * Drop 02_fix-email-mangling.patch (merged upstream)
  * Refresh 01_honour-build-flags.patch
  * Fix example usage in the makepage man (Closes: #813977)
  * Add patch to fix tests
  * Fix spelling-error-in-description
  * Bump Standards-Version to 3.9.8 (no changes needed)
  * Update Vcs links
  * Drop -dbg package

 -- Alessandro Ghedini <ghedo@debian.org>  Sat, 23 Apr 2016 13:07:08 +0100

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Priority: optional
 Maintainer: Alessandro Ghedini <ghedo@debian.org>
 Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.6
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/discount.git
-Vcs-Git: git://anonscm.debian.org/collab-maint/discount.git
+Standards-Version: 3.9.8
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/discount.git
+Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/discount.git
 Homepage: http://www.pell.portland.or.us/~orc/Code/discount/
 
 Package: discount
@@ -17,7 +17,7 @@
  implements all of the language described in the Markdown syntax document and
  passes the Markdown 1.0 test suite.
  .
- This package provides the discount excutables.
+ This package provides the discount executables.
 
 Package: libmarkdown2
 Section: libs
@@ -43,16 +43,3 @@
  passes the Markdown 1.0 test suite.
  .
  This package provides the development file for libmarkdown.
-
-Package: libmarkdown2-dbg
-Priority: extra
-Section: debug
-Architecture: any
-Depends: ${misc:Depends}, libmarkdown2 (= ${binary:Version})
-Multi-Arch: same
-Description: implementation of Markdown markup language in C (debug)
- Discount is an implementation of John Gruber's Markdown markup language. It
- implements all of the language described in the Markdown syntax document and
- passes the Markdown 1.0 test suite.
- .
- This package provide the debugging symbols for discount.

=== debian/rules ===
--- 
+++ 
@@ -16,7 +16,3 @@
 
 override_dh_auto_install:
 	dh_install
-
-override_dh_strip:
-	dh_strip -plibmarkdown2 --dbg-package=libmarkdown2-dbg
-	dh_strip --remaining-packages

## discount 2.2.3b8

=== debian/changelog ===
discount (2.2.3b8-2) unstable; urgency=medium

  * Bump Standards-Version to 4.1.1 (no changes needed)
  * Install libmarkdown.pc in libmarkdown2-dev

 -- Alessandro Ghedini <ghedo@debian.org>  Tue, 17 Oct 2017 22:19:31 +0100

discount (2.2.3b8-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.1.0 (no changes needed)
  * Mark discount Multi-Arch: foreign (Closes: #875905)
  * Update 03_fix-typo.patch

 -- Alessandro Ghedini <ghedo@debian.org>  Wed, 20 Sep 2017 09:33:51 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Priority: optional
 Maintainer: Alessandro Ghedini <ghedo@debian.org>
 Build-Depends: debhelper (>= 9)
-Standards-Version: 3.9.8
+Standards-Version: 4.1.1
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/discount.git
 Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/discount.git
 Homepage: http://www.pell.portland.or.us/~orc/Code/discount/
@@ -12,6 +12,7 @@
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}, libmarkdown2 (= ${binary:Version})
 Conflicts: markdown, libtext-markdown-perl
+Multi-Arch: foreign
 Description: implementation of the Markdown markup language in C
  Discount is an implementation of John Gruber's Markdown markup language. It
  implements all of the language described in the Markdown syntax document and

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

%:
	dh $@

CFLAGS += $(dpkg-buildflags --get CPPFLAGS)

override_dh_auto_configure:
	./configure.sh --shared                     \
		--prefix=/usr                           \
		--libdir=/usr/lib/$(DEB_HOST_MULTIARCH) \
		--with-id-anchor                        \
		--with-github-tags                      \
		--with-fenced-code                      \
		--with-dl=both                          \
		--debian-glitch

override_dh_auto_install:
	dh_install

## discount 2.2.4

=== cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.12)

project(DISCOUNT C)

get_filename_component(_ROOT "${CMAKE_CURRENT_LIST_DIR}" PATH)

file(READ "${_ROOT}/VERSION" ${PROJECT_NAME}_VERSION)
string(STRIP "${${PROJECT_NAME}_VERSION}" ${PROJECT_NAME}_VERSION)

set(${PROJECT_NAME}_WITH_TABSTOPS "4" CACHE STRING
    "Set tabstops to N characters (default is 4)")
set(TABSTOP "${${PROJECT_NAME}_WITH_TABSTOPS}")

set(${PROJECT_NAME}_MAKE_INSTALL ON CACHE BOOL
    "Set to OFF to disable install rules (default is ON)")

set(${PROJECT_NAME}_INSTALL_SAMPLES OFF CACHE BOOL
    "Set to ON to install sample programs (default is OFF)")

# Check headers
include(CheckIncludeFile)
check_include_file(libgen.h HAVE_LIBGEN_H)
check_include_file(pwd.h HAVE_PWD_H)
check_include_file(alloca.h HAVE_ALLOCA_H)
check_include_file(malloc.h HAVE_MALLOC_H)
check_include_file(sys/stat.h HAVE_STAT)

# Types detection (from configure.inc: AC_SCALAR_TYPES ())
include(CheckTypeSize)
check_type_size("unsigned long" SIZEOF_ULONG BUILTIN_TYPES_ONLY)
check_type_size("unsigned int" SIZEOF_UINT BUILTIN_TYPES_ONLY)
check_type_size("unsigned short" SIZEOF_USHORT BUILTIN_TYPES_ONLY)

if(SIZEOF_ULONG EQUAL 4)
    set(DWORD "unsigned long")
elseif(SIZEOF_UINT EQUAL 4)
    set(DWORD "unsigned int")
else()
    message(FATAL_ERROR "Could not detect DWORD type")
endif()

if(SIZEOF_UINT EQUAL 2)
    set(WORD "unsigned int")
elseif(SIZEOF_USHORT EQUAL 2)
    set(WORD "unsigned short")
else()
    message(FATAL_ERROR "Could not detect WORD type")
endif()

set(BYTE "unsigned char")

# Check symbols
include(CheckSymbolExists)
foreach(_symbol
        bzero
        strcasecmp _stricmp
        strncasecmp _strnicmp)
    string(TOUPPER ${_symbol} _SYMBOL)
    check_symbol_exists(${_symbol} string.h HAVE_${_SYMBOL})
endforeach()
check_symbol_exists(random stdlib.h HAVE_RANDOM)
check_symbol_exists(srandom stdlib.h HAVE_SRANDOM)
check_symbol_exists(getpwuid pwd.h HAVE_GETPWUID)
check_symbol_exists(basename libgen.h HAVE_BASENAME)
check_symbol_exists(fchdir unistd.h HAVE_FCHDIR)
if(HAVE_STAT)
    check_symbol_exists(S_ISCHR sys/stat.h HAVE_S_ISCHR)
    check_symbol_exists(S_ISFIFO sys/stat.h HAVE_S_ISFIFO)
    check_symbol_exists(S_ISSOCK sys/stat.h HAVE_S_ISSOCK)
endif()

if(NOT HAVE_BZERO)
    set(DEFINE_BZERO "#define bzero(p, n) memset(p, 0, n)")
endif()

if(NOT HAVE_STRCASECMP)
    if(HAVE__STRICMP)
        set(DEFINE_STRCASECMP "#define strcasecmp _stricmp")
    else()
        set(DEFINE_STRCASECMP "#error The symbol strcasecmp is not defined.")
    endif()
endif()

if(NOT HAVE_STRNCASECMP)
    if(HAVE__STRNICMP)
        set(DEFINE_STRNCASECMP "#define strncasecmp _strnicmp")
    else()
        set(DEFINE_STRNCASECMP "#error The symbol strncasecmp is not defined.")
    endif()
endif()

if(NOT HAVE_S_ISCHR OR NOT HAVE_S_ISFIFO OR NOT HAVE_S_ISSOCK)
    set(HAVE_STAT "")
endif()

configure_file(config.h.in
    "${_ROOT}/config.h"
    @ONLY)

configure_file("${_ROOT}/version.c.in"
    "${_ROOT}/version.c"
    @ONLY)
set_property(SOURCE "${_ROOT}/version.c" APPEND PROPERTY COMPILE_DEFINITIONS
    BRANCH=""
    VERSION="${${PROJECT_NAME}_VERSION}")

configure_file("${_ROOT}/mkdio.h.in"
    "${_ROOT}/mkdio.h"
    @ONLY)

include_directories("${_ROOT}")

add_executable(mktags
    "${_ROOT}/mktags.c")

add_custom_command(OUTPUT "${_ROOT}/blocktags"
    COMMAND mktags > blocktags
    WORKING_DIRECTORY "${_ROOT}")

add_library(libmarkdown
    "${_ROOT}/mkdio.c"
    "${_ROOT}/markdown.c"
    "${_ROOT}/dumptree.c"
    "${_ROOT}/generate.c"
    "${_ROOT}/resource.c"
    "${_ROOT}/docheader.c"
    "${_ROOT}/version.c"
    "${_ROOT}/toc.c"
    "${_ROOT}/css.c"
    "${_ROOT}/xml.c"
    "${_ROOT}/Csio.c"
    "${_ROOT}/xmlpage.c"
    "${_ROOT}/basename.c"
    "${_ROOT}/emmatch.c"
    "${_ROOT}/github_flavoured.c"
    "${_ROOT}/setup.c"
    "${_ROOT}/blocktags" "${_ROOT}/tags.c"
    "${_ROOT}/html5.c"
    "${_ROOT}/flags.c")

set_target_properties(libmarkdown PROPERTIES
    OUTPUT_NAME markdown)

add_library(common OBJECT
    "${_ROOT}/pgm_options.c"
    "${_ROOT}/gethopt.c")

add_executable(markdown
    "${_ROOT}/main.c"
    $<TARGET_OBJECTS:common>)

target_link_libraries(markdown PRIVATE libmarkdown)

add_executable(mkd2html
    "${_ROOT}/mkd2html.c"
    $<TARGET_OBJECTS:common>
    "${_ROOT}/notspecial.c")

target_link_libraries(mkd2html PRIVATE libmarkdown)

add_executable(makepage
    "${_ROOT}/makepage.c"
    $<TARGET_OBJECTS:common>)

target_link_libraries(makepage PRIVATE libmarkdown)

if(${PROJECT_NAME}_MAKE_INSTALL)
    string(TOLOWER ${PROJECT_NAME} _PACKAGE_NAME)
    include(GNUInstallDirs)
    if(NOT DEFINED CMAKE_INSTALL_CMAKEDIR)
        set(CMAKE_INSTALL_CMAKEDIR
            "${CMAKE_INSTALL_LIBDIR}/cmake/${_PACKAGE_NAME}"
            CACHE STRING "CMake packages")
    endif()
    install(FILES "${_ROOT}/mkdio.h"
        DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}")
    target_include_directories(libmarkdown INTERFACE
      $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>
    )
    set(_TARGETS libmarkdown markdown)
    if(${PROJECT_NAME}_INSTALL_SAMPLES)
        list(APPEND _TARGETS mkd2html makepage)
    endif()
    install(TARGETS ${_TARGETS} EXPORT ${_PACKAGE_NAME}-targets
        RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}"
        LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
        ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}")
    install(EXPORT ${_PACKAGE_NAME}-targets
        NAMESPACE ${_PACKAGE_NAME}::
        DESTINATION "${CMAKE_INSTALL_CMAKEDIR}")
    include(CMakePackageConfigHelpers)
    write_basic_package_version_file(
      "${CMAKE_CURRENT_BINARY_DIR}/${_PACKAGE_NAME}-config-version.cmake"
      VERSION ${${PROJECT_NAME}_VERSION}
      COMPATIBILITY AnyNewerVersion
    )
    configure_file("${CMAKE_CURRENT_LIST_DIR}/discount-config.cmake.in"
        "${CMAKE_CURRENT_BINARY_DIR}/${_PACKAGE_NAME}-config.cmake"
        @ONLY)
    install(FILES
        "${CMAKE_CURRENT_BINARY_DIR}/${_PACKAGE_NAME}-config.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/${_PACKAGE_NAME}-config-version.cmake"
        DESTINATION "${CMAKE_INSTALL_CMAKEDIR}")
    unset(_TARGETS)
    unset(_PACKAGE_NAME)
endif()

unset(_ROOT)

=== debian/changelog ===
discount (2.2.4-1) unstable; urgency=medium

  * New upstream release
    - Fix several heap buffer overflows as per CVE-2018-11468, CVE-2018-11503,
      CVE-2018-11504 and CVE-2018-12495 (Closes: #901912)
  * Update symbols file
  * Bump Standards-Version to 4.2.0 (no changes needed)
  * Drop 01_honour-build-flags.patch (not needed anymore)
  * Enable github-style checkboxes in lists

 -- Alessandro Ghedini <ghedo@debian.org>  Sat, 11 Aug 2018 12:46:55 +0100

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,10 @@
 Section: text
 Priority: optional
 Maintainer: Alessandro Ghedini <ghedo@debian.org>
-Build-Depends: debhelper (>= 9)
-Standards-Version: 4.1.1
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/discount.git
-Vcs-Browser: https://anonscm.debian.org/gitweb/?p=collab-maint/discount.git
+Build-Depends: debhelper (>= 11)
+Standards-Version: 4.2.0
+Vcs-Git: https://salsa.debian.org/debian/discount.git
+Vcs-Browser: https://salsa.debian.org/debian/discount
 Homepage: http://www.pell.portland.or.us/~orc/Code/discount/
 
 Package: discount

=== debian/rules ===
--- 
+++ 
@@ -14,6 +14,7 @@
 		--with-github-tags                      \
 		--with-fenced-code                      \
 		--with-dl=both                          \
+		--github-checkbox                       \
 		--debian-glitch
 
 override_dh_auto_install:

## discount 2.2.6

=== debian/changelog ===
discount (2.2.6-1) unstable; urgency=medium

  * New upstream release
  * Bump STandards-Version to 4.4.0 (no changes needed)
  * Refresh patches
  * Bump debhelper compat level to 12
  * Disable parallel builds due to failures
  * Update symbols file
  * Add Build-Depends-Package field to symbols file

 -- Alessandro Ghedini <ghedo@debian.org>  Fri, 12 Jul 2019 19:53:47 +0100

=== debian/control ===
--- 
+++ 
@@ -2,8 +2,8 @@
 Section: text
 Priority: optional
 Maintainer: Alessandro Ghedini <ghedo@debian.org>
-Build-Depends: debhelper (>= 11)
-Standards-Version: 4.2.0
+Build-Depends: debhelper (>= 12)
+Standards-Version: 4.4.0
 Vcs-Git: https://salsa.debian.org/debian/discount.git
 Vcs-Browser: https://salsa.debian.org/debian/discount
 Homepage: http://www.pell.portland.or.us/~orc/Code/discount/

=== debian/rules ===
--- 
+++ 
@@ -2,7 +2,7 @@
 #export DH_VERBOSE=1
 
 %:
-	dh $@
+	dh $@ --no-parallel
 
 CFLAGS += $(dpkg-buildflags --get CPPFLAGS)

=== debian/watch ===
version=3
opts=filenamemangle=s/.+\/v?(\d\S*)\.tar\.gz/discount-$1.tar.gz/ \
  https://github.com/Orc/discount/tags .*/v?(\d\S*)\.tar\.gz

## discount 2.2.7

=== debian/changelog ===
discount (2.2.7-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/patches/0004-fix-build-with-gcc14.patch: Fix build with GCC 14.
    Thanks to Atri Bhattacharya and Florian Ernst (Closes: #1074915).

 -- Marcos Talau <talau@debian.org>  Wed, 13 Nov 2024 12:32:17 -0300

discount (2.2.7-2) unstable; urgency=medium

  [ Balint Reczey ]
  * debian/gitlab-ci.yml: Add simple Salsa CI configuration
  * Really honour CPPFLAGS and also LDFLAGS during the build

 -- Alessandro Ghedini <ghedo@debian.org>  Fri, 03 Sep 2021 18:37:06 +0100

discount (2.2.7-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.6.0 (no changes needed)
  * Bump debhelper compat level to 13
  * Bump debian/watch version to 4

 -- Alessandro Ghedini <ghedo@debian.org>  Fri, 03 Sep 2021 18:25:23 +0100

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,6 @@
 %:
 	dh $@ --no-parallel
 
-CFLAGS += $(dpkg-buildflags --get CPPFLAGS)
 
 override_dh_auto_configure:
 	./configure.sh --shared                     \

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@discount@-$1.tar.gz%" \
    https://github.com/Orc/discount/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## discount 2.2.7-2build1trisquel1

=== debian/changelog ===
discount (2.2.7-2build1trisquel1) ecne; urgency=medium

  * Rebuild as dependency of aptitude for i386

 -- Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>  Thu, 02 Oct 2025 03:10:41 +0000

discount (2.2.7-2build1) noble; urgency=high

  * No change rebuild for 64-bit time_t and frame pointers.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 08 Apr 2024 17:56:03 +0200

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,10 @@
 Source: discount
 Section: text
 Priority: optional
-Maintainer: Alessandro Ghedini <ghedo@debian.org>
-Build-Depends: debhelper (>= 12)
-Standards-Version: 4.4.0
+Maintainer: Trisquel GNU/Linux developers <trisquel-devel@listas.trisquel.info>
+XSBC-Original-Maintainer: Alessandro Ghedini <ghedo@debian.org>
+Build-Depends: debhelper-compat (= 13)
+Standards-Version: 4.6.0
 Vcs-Git: https://salsa.debian.org/debian/discount.git
 Vcs-Browser: https://salsa.debian.org/debian/discount
 Homepage: http://www.pell.portland.or.us/~orc/Code/discount/
